-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassFrameWindow.chs

-- 

module HGamer3D.Bindings.CEGUI.ClassFrameWindow where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.CEGUI.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}
import HGamer3D.Bindings.CEGUI.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}
import HGamer3D.Bindings.CEGUI.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Initialises the Window - Details: This must be called for every window created. Normally this is handled automatically by the WindowFactory for each Window
initialiseComponents :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ return value - Nothing     
initialiseComponents a1 =
  withHG3DClass a1 $ \a1' -> 
  initialiseComponents'_ a1' >>= \res ->
  return ()
{-# LINE 47 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Return whether this window is sizable. Note that this requires that the window have an enabled frame and that sizing itself is enabled. 
isSizingEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if the window can be sized, false if the window can not be sized     
isSizingEnabled a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isSizingEnabled'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 52 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Return whether the frame for this window is enabled. 
isFrameEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if the frame for this window is enabled, false if the frame for this window is disabled.     
isFrameEnabled a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isFrameEnabled'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 57 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Return whether the title bar for this window is enabled. 
isTitleBarEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if the window has a title bar and it is enabled, false if the window has no title bar or if the title bar is disabled.     
isTitleBarEnabled a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isTitleBarEnabled'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 62 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Return whether this close button for this window is enabled. 
isCloseButtonEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if the window has a close button and it is enabled, false if the window either has no close button or if the close button is disabled.     
isCloseButtonEnabled a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isCloseButtonEnabled'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 67 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Return whether roll up (a.k.a shading) is enabled for this window. 
isRollupEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if roll up is enabled, false if roll up is disabled.     
isRollupEnabled a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isRollupEnabled'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 72 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Return whether the window is currently rolled up (a.k.a shaded). 
isRolledup :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if the window is rolled up, false if the window is not rolled up.     
isRolledup a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isRolledup'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 77 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Return the thickness of the sizing border. 
getSizingBorderThickness :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Float)
 -- ^ return value - float value describing the thickness of the sizing border in screen pixels.     
getSizingBorderThickness a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getSizingBorderThickness'_ a1' a2' >>= \res ->
  peekFloatConv  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 82 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Enables or disables sizing for this window. 
setSizingEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - set to true to enable sizing (also requires frame to be enabled), or false to disable sizing.
  ->  IO ()
 -- ^ return value - nothing     
setSizingEnabled a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setSizingEnabled'_ a1' a2' >>= \res ->
  return ()
{-# LINE 87 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Enables or disables the frame for this window. 
setFrameEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - set to true to enable the frame for this window, or false to disable the frame for this window.
  ->  IO ()
 -- ^ return value - Nothing.     
setFrameEnabled a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setFrameEnabled'_ a1' a2' >>= \res ->
  return ()
{-# LINE 92 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Enables or disables the title bar for the frame window. 
setTitleBarEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - set to true to enable the title bar (if one is attached), or false to disable the title bar.
  ->  IO ()
 -- ^ return value - Nothing.     
setTitleBarEnabled a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setTitleBarEnabled'_ a1' a2' >>= \res ->
  return ()
{-# LINE 97 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Enables or disables the close button for the frame window. 
setCloseButtonEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - Set to true to enable the close button (if one is attached), or false to disable the close button.
  ->  IO ()
 -- ^ return value - Nothing.     
setCloseButtonEnabled a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setCloseButtonEnabled'_ a1' a2' >>= \res ->
  return ()
{-# LINE 102 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Enables or disables roll-up (shading) for this window. 
setRollupEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - Set to true to enable roll-up for the frame window, or false to disable roll-up.
  ->  IO ()
 -- ^ return value - Nothing.     
setRollupEnabled a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setRollupEnabled'_ a1' a2' >>= \res ->
  return ()
{-# LINE 107 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Toggles the state of the window between rolled-up (shaded) and normal sizes. This requires roll-up to be enabled. 
toggleRollup :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ return value - Nothing     
toggleRollup a1 =
  withHG3DClass a1 $ \a1' -> 
  toggleRollup'_ a1' >>= \res ->
  return ()
{-# LINE 111 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Set the size of the sizing border for this window. 
setSizingBorderThickness :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Float  -- ^ pixels - float value specifying the thickness for the sizing border in screen pixels.
  ->  IO ()
 -- ^ return value - Nothing.     
setSizingBorderThickness a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = realToFrac a2} in 
  setSizingBorderThickness'_ a1' a2' >>= \res ->
  return ()
{-# LINE 116 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Return whether this FrameWindow
isDragMovingEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if the     
isDragMovingEnabled a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isDragMovingEnabled'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 121 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Set whether this FrameWindow
setDragMovingEnabled :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - true if the Window should move when the user drags the title bar, false if the window should not move.
  ->  IO ()
 -- ^ return value - Nothing.     
setDragMovingEnabled a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setDragMovingEnabled'_ a1' a2' >>= \res ->
  return ()
{-# LINE 126 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Set the image to be used for the north-south sizing mouse cursor. 
setNSSizingCursorImage2 :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ imageset - String holding the name of the Imageset containing the Image to be used.
  ->  String  -- ^ image - String holding the name of the Image to be used.
  ->  IO ()
 -- ^ return value - Nothing.    
setNSSizingCursorImage2 a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  withCString a3 $ \a3' -> 
  setNSSizingCursorImage2'_ a1' a2' a3' >>= \res ->
  return ()
{-# LINE 132 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Set the image to be used for the east-west sizing mouse cursor. 
setEWSizingCursorImage2 :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ imageset - String holding the name of the Imageset containing the Image to be used.
  ->  String  -- ^ image - String holding the name of the Image to be used.
  ->  IO ()
 -- ^ return value - Nothing.    
setEWSizingCursorImage2 a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  withCString a3 $ \a3' -> 
  setEWSizingCursorImage2'_ a1' a2' a3' >>= \res ->
  return ()
{-# LINE 138 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Set the image to be used for the northwest-southeast sizing mouse cursor. 
setNWSESizingCursorImage2 :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ imageset - String holding the name of the Imageset containing the Image to be used.
  ->  String  -- ^ image - String holding the name of the Image to be used.
  ->  IO ()
 -- ^ return value - Nothing.    
setNWSESizingCursorImage2 a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  withCString a3 $ \a3' -> 
  setNWSESizingCursorImage2'_ a1' a2' a3' >>= \res ->
  return ()
{-# LINE 144 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Set the image to be used for the northeast-southwest sizing mouse cursor. 
setNESWSizingCursorImage2 :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ imageset - String holding the name of the Imageset containing the Image to be used.
  ->  String  -- ^ image - String holding the name of the Image to be used.
  ->  IO ()
 -- ^ return value - Nothing.    
setNESWSizingCursorImage2 a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  withCString a3 $ \a3' -> 
  setNESWSizingCursorImage2'_ a1' a2' a3' >>= \res ->
  return ()
{-# LINE 150 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Return a pointer to the close button component widget for this FrameWindow
getCloseButton :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (HG3DClass)
 -- ^ return value - Pointer to a     
getCloseButton a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getCloseButton'_ a1' a2' >>= \res ->
  peek  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 155 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Constructor for FrameWindow
new :: String  -- ^ type
  ->  String  -- ^ name
  ->  IO (HG3DClass)
 -- ^ 
new a1 a2 =
  withCString a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  new'_ a1' a2' a3' >>= \res ->
  peek  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 161 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}

-- | Destructor for FramwWindow objects. 
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 165 ".\\HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_initialiseComponents"
  initialiseComponents'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_isSizingEnabled"
  isSizingEnabled'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_isFrameEnabled"
  isFrameEnabled'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_isTitleBarEnabled"
  isTitleBarEnabled'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_isCloseButtonEnabled"
  isCloseButtonEnabled'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_isRollupEnabled"
  isRollupEnabled'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_isRolledup"
  isRolledup'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_getSizingBorderThickness"
  getSizingBorderThickness'_ :: ((HG3DClassPtr) -> ((Ptr CFloat) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setSizingEnabled"
  setSizingEnabled'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setFrameEnabled"
  setFrameEnabled'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setTitleBarEnabled"
  setTitleBarEnabled'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setCloseButtonEnabled"
  setCloseButtonEnabled'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setRollupEnabled"
  setRollupEnabled'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_toggleRollup"
  toggleRollup'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setSizingBorderThickness"
  setSizingBorderThickness'_ :: ((HG3DClassPtr) -> (CFloat -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_isDragMovingEnabled"
  isDragMovingEnabled'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setDragMovingEnabled"
  setDragMovingEnabled'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setNSSizingCursorImage2"
  setNSSizingCursorImage2'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CChar) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setEWSizingCursorImage2"
  setEWSizingCursorImage2'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CChar) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setNWSESizingCursorImage2"
  setNWSESizingCursorImage2'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CChar) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_setNESWSizingCursorImage2"
  setNESWSizingCursorImage2'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> ((Ptr CChar) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_getCloseButton"
  getCloseButton'_ :: ((HG3DClassPtr) -> ((HG3DClassPtr) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_construct"
  new'_ :: ((Ptr CChar) -> ((Ptr CChar) -> ((HG3DClassPtr) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassFrameWindow.chs.h cegui_frmwndw_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))
