-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassLogger.chs

-- 

module HGamer3D.Bindings.CEGUI.ClassLogger where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.CEGUI.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs" #-}
import HGamer3D.Bindings.CEGUI.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs" #-}
import HGamer3D.Bindings.CEGUI.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs" #-}
import HGamer3D.Bindings.CEGUI.EnumLoggingLevel
{-# LINE 43 ".\\HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs" #-}

-- | Destructor for Logger
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 48 ".\\HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs" #-}

-- | Set the level of logging information that will get out to the log file. 
setLoggingLevel :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  EnumLoggingLevel  -- ^ level - One of the LoggingLevel enumerated values that specified the level of logging information required.
  ->  IO ()
 -- ^ return value - Nothing     
setLoggingLevel a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = cIntFromEnum a2} in 
  setLoggingLevel'_ a1' a2' >>= \res ->
  return ()
{-# LINE 53 ".\\HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs" #-}

-- | return the current logging level setting 
getLoggingLevel :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (EnumLoggingLevel)
 -- ^ return value - One of the LoggingLevel enumerated values specifying the current level of logging     
getLoggingLevel a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getLoggingLevel'_ a1' a2' >>= \res ->
  peekEnumUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 58 ".\\HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs" #-}

-- | Add an event to the log. 
logEvent :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ message - String object containing the message to be added to the event log.
  ->  EnumLoggingLevel  -- ^ level - LoggingLevel for this message. If level is greater than the current set logging level, the message is not logged.
  ->  IO ()
 -- ^ return value - Nothing     
logEvent a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  let {a3' = cIntFromEnum a3} in 
  logEvent'_ a1' a2' a3' >>= \res ->
  return ()
{-# LINE 64 ".\\HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs" #-}

-- | Set the name of the log file where all subsequent log entries should be written. The interpretation of file name may differ depending on the concrete logger implementation.  - Details: When this is called, and the log file is created, any cached log entries are flushed to the log file.
setLogFilename :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  String  -- ^ filename - Name of the file to put log messages.
  ->  Bool  -- ^ append - 
--
--
  ->  IO ()
 -- ^ 
setLogFilename a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  let {a3' = fromBool a3} in 
  setLogFilename'_ a1' a2' a3' >>= \res ->
  return ()
{-# LINE 70 ".\\HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs.h cegui_lggr_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs.h cegui_lggr_setLoggingLevel"
  setLoggingLevel'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs.h cegui_lggr_getLoggingLevel"
  getLoggingLevel'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs.h cegui_lggr_logEvent"
  logEvent'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (CInt -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassLogger.chs.h cegui_lggr_setLogFilename"
  setLogFilename'_ :: ((HG3DClassPtr) -> ((Ptr CChar) -> (CInt -> (IO ()))))
