-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassProgressBar.chs

-- 

module HGamer3D.Bindings.CEGUI.ClassProgressBar where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.CEGUI.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}
import HGamer3D.Bindings.CEGUI.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}
import HGamer3D.Bindings.CEGUI.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}

-- | return the current progress value 
getProgress :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Float)
 -- ^ 
getProgress a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getProgress'_ a1' a2' >>= \res ->
  peekFloatConv  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 48 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}

-- | return the current step size 
getStep :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Float)
 -- ^ 
getStep a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  getStep'_ a1' a2' >>= \res ->
  peekFloatConv  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 53 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}

-- | set the current progress. 
setProgress :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Float  -- ^ progress - The level of progress to set. If this value is >1.0f (100%) progress will be limited to 1.0f.
  ->  IO ()
 -- ^ return value - Nothing.     
setProgress a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = realToFrac a2} in 
  setProgress'_ a1' a2' >>= \res ->
  return ()
{-# LINE 58 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}

-- | set the size of the 'step' in percentage points (default is 0.01f or 1%). 
setStepSize :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Float  -- ^ step_val
  ->  IO ()
 -- ^ return value - Nothing.     
setStepSize a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = realToFrac a2} in 
  setStepSize'_ a1' a2' >>= \res ->
  return ()
{-# LINE 63 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}

-- | cause the progress to step  - Details: The amount the progress bar will step can be changed by calling the setStepSize method.  The
--default step size is 0.01f which is equal to 1%.
--
step :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO ()
 -- ^ 
step a1 =
  withHG3DClass a1 $ \a1' -> 
  step'_ a1' >>= \res ->
  return ()
{-# LINE 67 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}

-- | Modify the progress level by a specified delta. 
adjustProgress :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Float  -- ^ delta - amount to adjust the progress by. Whatever this value is, the progress of the bar will be kept within the range: 0.0f <= progress <= 1.0f.
  ->  IO ()
 -- ^ return value - Nothing.     
adjustProgress a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = realToFrac a2} in 
  adjustProgress'_ a1' a2' >>= \res ->
  return ()
{-# LINE 72 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}

-- | Constructor for ProgressBar
new :: String  -- ^ type
  ->  String  -- ^ name
  ->  IO (HG3DClass)
 -- ^ 
new a1 a2 =
  withCString a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  new'_ a1' a2' a3' >>= \res ->
  peek  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 78 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}

-- | Destructor for ProgressBar
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 82 ".\\HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs.h cegui_prgbr_getProgress"
  getProgress'_ :: ((HG3DClassPtr) -> ((Ptr CFloat) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs.h cegui_prgbr_getStep"
  getStep'_ :: ((HG3DClassPtr) -> ((Ptr CFloat) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs.h cegui_prgbr_setProgress"
  setProgress'_ :: ((HG3DClassPtr) -> (CFloat -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs.h cegui_prgbr_setStepSize"
  setStepSize'_ :: ((HG3DClassPtr) -> (CFloat -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs.h cegui_prgbr_step"
  step'_ :: ((HG3DClassPtr) -> (IO ()))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs.h cegui_prgbr_adjustProgress"
  adjustProgress'_ :: ((HG3DClassPtr) -> (CFloat -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs.h cegui_prgbr_construct"
  new'_ :: ((Ptr CChar) -> ((Ptr CChar) -> ((HG3DClassPtr) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassProgressBar.chs.h cegui_prgbr_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))
