-- GENERATED by C->Haskell Compiler, version 0.16.3 Crystal Seed, 24 Jan 2009 (Haskell)
-- Edit the ORIGNAL .chs file instead!


{-# LINE 1 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}{-# LANGUAGE ForeignFunctionInterface #-}
{-# LANGUAGE TypeSynonymInstances #-}

-- This source file is part of HGamer3D
-- (A project to enable 3D game development in Haskell)
-- For the latest info, see http://www.althainz.de/HGamer3D.html
-- 

-- (c) 2011, 2012 Peter Althainz
-- 
-- Licensed under the Apache License, Version 2.0 (the "License");
-- you may not use this file except in compliance with the License.
-- You may obtain a copy of the License at
-- 
--     http://www.apache.org/licenses/LICENSE-2.0
-- 
-- Unless required by applicable law or agreed to in writing, software
-- distributed under the License is distributed on an "AS IS" BASIS,
-- WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-- See the License for the specific language governing permissions and
-- limitations under the License.
-- 


-- ClassThumb.chs

-- 

module HGamer3D.Bindings.CEGUI.ClassThumb where

import Foreign
import Foreign.Ptr
import Foreign.C

import HGamer3D.Data.HG3DClass
import HGamer3D.Data.Vector
import HGamer3D.Data.Colour
import HGamer3D.Data.Angle

import HGamer3D.Bindings.CEGUI.Utils
{-# LINE 40 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}
import HGamer3D.Bindings.CEGUI.ClassPtr
{-# LINE 41 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}
import HGamer3D.Bindings.CEGUI.StructHG3DClass
{-# LINE 42 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}

-- | return whether hot-tracking is enabled or not. 
isHotTracked :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if hot-tracking is enabled. false if hot-tracking is disabled.     
isHotTracked a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isHotTracked'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 48 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}

-- | return whether the thumb is movable on the vertical axis. 
isVertFree :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if the thumb is movable along the vertical axis. false if the thumb is fixed on the vertical axis.     
isVertFree a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isVertFree'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 53 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}

-- | return whether the thumb is movable on the horizontal axis. 
isHorzFree :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  IO (Bool)
 -- ^ return value - true if the thumb is movable along the horizontal axis. false if the thumb is fixed on the horizontal axis.     
isHorzFree a1 =
  withHG3DClass a1 $ \a1' -> 
  alloca $ \a2' -> 
  isHorzFree'_ a1' a2' >>= \res ->
  peekBoolUtil  a2'>>= \a2'' -> 
  return (a2'')
{-# LINE 58 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}

-- | set whether the thumb uses hot-tracking. 
setHotTracked :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - true to enable hot-tracking. false to disable hot-tracking.
  ->  IO ()
 -- ^ return value - Nothing.     
setHotTracked a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setHotTracked'_ a1' a2' >>= \res ->
  return ()
{-# LINE 63 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}

-- | set whether thumb is movable on the vertical axis. 
setVertFree :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - true to allow movement of thumb along the vertical axis. false to fix thumb on the vertical axis.
  ->  IO ()
 -- ^ return value - nothing.     
setVertFree a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setVertFree'_ a1' a2' >>= \res ->
  return ()
{-# LINE 68 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}

-- | set whether thumb is movable on the horizontal axis. 
setHorzFree :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Bool  -- ^ setting - true to allow movement of thumb along the horizontal axis. false to fix thumb on the horizontal axis.
  ->  IO ()
 -- ^ return value - nothing.     
setHorzFree a1 a2 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = fromBool a2} in 
  setHorzFree'_ a1' a2' >>= \res ->
  return ()
{-# LINE 73 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}

-- | set the movement range of the thumb for the vertical axis.  - Details: The values specified here are relative to the parent window for the thumb, and are specified in whichever
--metrics mode is active for the widget.
--
setVertRange :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Float  -- ^ min
  ->  Float  -- ^ max
  ->  IO ()
 -- ^ 
setVertRange a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = realToFrac a2} in 
  let {a3' = realToFrac a3} in 
  setVertRange'_ a1' a2' a3' >>= \res ->
  return ()
{-# LINE 79 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}

-- | set the movement range of the thumb for the horizontal axis.  - Details: The values specified here are relative to the parent window for the thumb, and are specified in whichever
--metrics mode is active for the widget.
--
setHorzRange :: HG3DClass  -- ^ classpointer - pointer of Class instance from which this methods is called.
  ->  Float  -- ^ min
  ->  Float  -- ^ max
  ->  IO ()
 -- ^ 
setHorzRange a1 a2 a3 =
  withHG3DClass a1 $ \a1' -> 
  let {a2' = realToFrac a2} in 
  let {a3' = realToFrac a3} in 
  setHorzRange'_ a1' a2' a3' >>= \res ->
  return ()
{-# LINE 85 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}

-- | Constructor for Thumb
new :: String  -- ^ type
  ->  String  -- ^ name
  ->  IO (HG3DClass)
 -- ^ 
new a1 a2 =
  withCString a1 $ \a1' -> 
  withCString a2 $ \a2' -> 
  alloca $ \a3' -> 
  new'_ a1' a2' a3' >>= \res ->
  peek  a3'>>= \a3'' -> 
  return (a3'')
{-# LINE 91 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}

-- | Destructor for Thumb
delete :: HG3DClass  -- ^ classpointer - pointer of Class instance which is going to be deleted.
  ->  IO ()
 -- ^ 
delete a1 =
  withHG3DClass a1 $ \a1' -> 
  delete'_ a1' >>= \res ->
  return ()
{-# LINE 95 ".\\HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs" #-}


foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs.h cegui_thmb_isHotTracked"
  isHotTracked'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs.h cegui_thmb_isVertFree"
  isVertFree'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs.h cegui_thmb_isHorzFree"
  isHorzFree'_ :: ((HG3DClassPtr) -> ((Ptr CInt) -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs.h cegui_thmb_setHotTracked"
  setHotTracked'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs.h cegui_thmb_setVertFree"
  setVertFree'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs.h cegui_thmb_setHorzFree"
  setHorzFree'_ :: ((HG3DClassPtr) -> (CInt -> (IO ())))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs.h cegui_thmb_setVertRange"
  setVertRange'_ :: ((HG3DClassPtr) -> (CFloat -> (CFloat -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs.h cegui_thmb_setHorzRange"
  setHorzRange'_ :: ((HG3DClassPtr) -> (CFloat -> (CFloat -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs.h cegui_thmb_construct"
  new'_ :: ((Ptr CChar) -> ((Ptr CChar) -> ((HG3DClassPtr) -> (IO ()))))

foreign import ccall safe "HGamer3D\\Bindings\\CEGUI\\ClassThumb.chs.h cegui_thmb_destruct"
  delete'_ :: ((HG3DClassPtr) -> (IO ()))
